



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>POJ 2226二分图最大匹配</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">POJ 2226二分图最大匹配</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 05:40:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>匈牙利算法是由匈牙利数学家Edmonds于1965年提出，因而得名。匈牙利算法是基于<a href="http://baike.baidu.com/view/4509786.htm" rel="external nofollow noreferrer">Hall定理</a>中充分性证明的思想，它是二部图<a href="http://baike.baidu.com/view/352573.htm" rel="external nofollow noreferrer">匹配</a>最常见的算法，该算法的核心就是寻找<a href="http://baike.baidu.com/view/3585026.htm" rel="external nofollow noreferrer">增广路</a>径，它是一种用增广路径求二分图最大匹配的算法。</p>
<div>
<pre class="prettyprint linenums">#include&lt;stdio.h&gt;<br />
#include&lt;string.h&gt;<br />
#include&lt;stdlib.h&gt;<br />
int n1,n2;<br />
char map[][];  //数组开大点<br />
int mapx[][],mapy[][];<br />
int ma[][];//邻接矩阵true代表有边相连<br />
int result[],visit[];<br />
int x,y;

int find(int a){<br />
    int i;<br />
    for(i=;i&lt;=y;i++){<br />
        if(!visit[i]&amp;&amp;ma[a][i]){//如果节点i与a相邻并且未被查找过<br />
            visit[i]=;//标记i为已查找过<br />
            if(!result[i]||find(result[i])){//如果i未在前一个匹配M中或者i在匹配M中，但是从与i相邻的节点出发可以有增广路<br />
                result[i]=a;//记录查找成功记录<br />
                return ;<br />
            }<br />
        }<br />
    }<br />
    return ;<br />
}

int main(){<br />
    int i,j,ans;<br />
    while(scanf("%d%d",&amp;n1,&amp;n2)!=EOF){<br />
        for(i=;i&lt;n1;i++){<br />
            scanf("%s",map[i]);<br />
        }<br />
        memset(mapx,,sizeof(mapx));<br />
        memset(mapy,,sizeof(mapy));<br />
        x=;<br />
        for(i=;i&lt;n1;i++){<br />
            for(j=;j&lt;n2;j++){<br />
                if(map[i][j]=='*'){<br />
                    ++x;<br />
                    while(j&lt;n2&amp;&amp;map[i][j]=='*'){<br />
                        mapx[i][j]=x;<br />
                        j++;<br />
                    }<br />
                }<br />
            }<br />
        }<br />
        y=;<br />
        for(j=;j&lt;n2;j++){<br />
            for(i=;i&lt;n1;i++){<br />
                if(map[i][j]=='*'){<br />
                    ++y;<br />
                    while(i&lt;n1&amp;&amp;map[i][j]=='*'){<br />
                        mapy[i][j]=y;<br />
                        i++;<br />
                    }<br />
                }<br />
            }<br />
        }

        for(i=;i&lt;n1;i++){<br />
            for(j=;j&lt;n2;j++){<br />
                ma[mapx[i][j]][mapy[i][j]]=;<br />
            }<br />
        }

        ans=;

        memset(result,,sizeof(result));<br />
        for(i=;i&lt;=x;i++){<br />
            memset(visit,,sizeof(visit));//清空上次搜索时的标记<br />
            ans+=find(i); //从节点i尝试扩展<br />
        }<br />
        printf("%d\n",ans);<br />
    }<br />
    return ;<br />
}</pre>
</div>
<p>http://blog.csdn.net/pi9nc/article/details/11848327</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvzrjz9.html">css3的新特性transform&comma;transition&comma;animation</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p3lwkq.html">How to backup your blogs on cnblogs</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mynx68.html">FIFO</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jomngq.html">PHP获取日期</a>
		</li>
						<li><a href="https://www.batexi.com/a/390gew38.html">SIFT 特征提取算法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/390ojy49.html">最长递增子序列问题 nyoj 17单调递增最长子序列 nyoj 79拦截导弹</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmeevl9.html">&lbrack;微软&rsqb;technet与msdn</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7o21q.html">StoreKit framework</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvkmj1q.html">常用小方法 or 语法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jg2xx8.html">如何写SysV服务管理脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj2g4pq.html">mysql 常用sql语句 一</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwyrk9.html">【Luogu1876】开灯（数论）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzoklw8.html">docker 安装 MySQL 8，并减少内存占用 记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvx20k8.html">BZOJ2553&lbrack;BeiJing2011&rsqb;禁忌&mdash;&mdash;AC自动机&plus;概率DP&plus;矩阵乘法</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1nzj19.html">关于一致性hash详细</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn6ln4q.html">Mysql不改默认侦听回环地址而ssh通道连接的办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qven74y9.html">SMACH专题（四）----状态State类的实现和中文注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnvod4q.html">题解 P1765 【手机&lowbar;NOI导刊2010普及（10）】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpnez49.html">linode使用apt更新时停止的错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvd1znzq.html">MVC Pager使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qxn4de8.html">c&num;线程带参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qydol2q.html">0104探究MySQL优化器对索引和JOIN顺序的选择</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96og4n9.html">OpenStack从入门到放弃</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mnz32q.html">&lbrack;HTML5&rsqb; ArrayBuffer与类型化数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k1z579.html">源码编译安装postgresql</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2wl5vq.html">Linux服务器SSH无密码访问</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvvm0yq.html">maven引入多个spring jar包中存在同名文件的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxnm6e8.html">Python环境配置安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mn53oq.html">maven   log4g 用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1z1j59.html">Forward&plus;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
